#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <clientprefs>

#undef REQUIRE_PLUGIN
#include <adminmenu>
#define REQUIRE_PLUGIN

#define PLUGIN_VERSION "1.5.2"

// chat colors
#define YELLOW "\x01"
#define TEAMCOLOR "\x03"
#define GREEN "\x04"

// CVAR-Handles
new Handle:cvar_Bankversion = INVALID_HANDLE;
new Handle:cvar_Bankenable = INVALID_HANDLE;
new Handle:cvar_Bankmaxbank = INVALID_HANDLE;
new Handle:cvar_Bankannounce = INVALID_HANDLE;
new Handle:cvar_Bankdepositfee = INVALID_HANDLE;
new Handle:cvar_Bankinterest = INVALID_HANDLE;
new Handle:cvar_Bankmindep = INVALID_HANDLE;
new Handle:cvar_Bankpistolround = INVALID_HANDLE;
new Handle:cvar_Bankidentity = INVALID_HANDLE;
new Handle:cvar_Bankminplayers = INVALID_HANDLE;
new Handle:cvar_Bankdbconfig = INVALID_HANDLE;
new Handle:cvar_Bankmapprefixes = INVALID_HANDLE;
new Handle:cvar_Bankmapmode = INVALID_HANDLE;
new Handle:cvar_Bankdefaultautodep = INVALID_HANDLE;
new Handle:cvar_Bankdefaultautowith = INVALID_HANDLE;
new Handle:cvar_Bankadminlimit = INVALID_HANDLE;
new Handle:cvar_Bankadminflag = INVALID_HANDLE;
new Handle:cvar_Bankresetinterval = INVALID_HANDLE;
new Handle:cvar_Bankprunedb = INVALID_HANDLE;
new Handle:cvar_Bankaddtoadminmenu = INVALID_HANDLE;
new Handle:cvar_mp_maxrounds = INVALID_HANDLE;
new Handle:cvar_mp_maxmoney = INVALID_HANDLE;
new Handle:cvar_mp_halftime = INVALID_HANDLE;
new Handle:cvar_Bankmaxtransfer = INVALID_HANDLE;
new Handle:cvar_Bankdefaultbank = INVALID_HANDLE;

new Handle:db = INVALID_HANDLE;
new Handle:hAdminMenu = INVALID_HANDLE;

// CVARS
new String:cvplugin_name[128];
new String:cvintereststr[32];
new String:cvbankadminflag[64];
new Float:cvinterestflt;
new cvbankenable;
new cvfeeint;
new cvmaxbankmoney;
new cvbankannounce;
new cvmindepamount;
new cvpistolround;
new cvminrealplayers;
new cvdefaultautodep;
new cvdefaultautowith;
new cvbankadminlimit;
new cvbankresetinterval;
new cvbankprunedb;
new cvmpmaxmoney;
new cvmpmaxrounds;
new cvmphalftime;
new cvmaxtransfer;
new cvdefaultbank;

new String:plugin_name[128];
new maxclients;
new bankresettimestamp;

new bool:IHateFloods[MAXPLAYERS + 1];
new bool:AdminOperation[MAXPLAYERS + 1];
new bool:IsChatInput[MAXPLAYERS + 1] = false;
new bool:IsBankMap;
new bool:IsAdmin[MAXPLAYERS + 1] = false;
new bool:lateLoaded = false;
new bool:IsLastHalftimeRound = false;
new bool:IsGameCsgo = false;

new PlugMes[MAXPLAYERS + 1];
new HideRank[MAXPLAYERS + 1];
new LastMenuAction[MAXPLAYERS + 1];
new AutoDeposit[MAXPLAYERS + 1];
new AutoWithdraw[MAXPLAYERS + 1];
new BankMoney[MAXPLAYERS + 1];
new DBid[MAXPLAYERS + 1];
new TargetClientMenu[MAXPLAYERS + 1];
new ClientChatInput[MAXPLAYERS + 1];

new g_iAccount = -1;
new g_bIsControllingBot = -1;

new bool:DebugMode = false;

#include "cssbank/database.sp"
#include "cssbank/commands.sp"
#include "cssbank/money.sp"
#include "cssbank/menus.sp"

// Plugin definitions
public Plugin:myinfo =
{
	name = "CSS Bank",
	author = "Miraculix",
	description = "A player can deposit money to the bank, transfer it to other players or withdraw when needed.",
	version = PLUGIN_VERSION,
	url = "http://forums.alliedmods.net/showthread.php?p=1109391"
};

// if the plugin was loaded late we have a bunch of initialization that needs to be done
public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	// Backwards compatibility pre csgo/sm1.5
	MarkNativeAsOptional("GetUserMessageType");

	lateLoaded = late;
	return APLRes_Success;
}

public OnPluginStart()
{
	LoadTranslations("cssbank.phrases");

	// ConVars
	cvar_Bankversion = CreateConVar("css_bank_version", PLUGIN_VERSION, "CSS Bank Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	cvar_Bankenable = CreateConVar("css_bank_enable","1","Turns Bank On/Off",FCVAR_PLUGIN);
	cvar_Bankmaxbank = CreateConVar("css_bank_maximum","250000","Maximun amount of money players are allowed to have in the bank, 0 to disable (max 2,000,000,000)",FCVAR_PLUGIN);
	cvar_Bankannounce = CreateConVar("css_bank_announce","1.0","Turns on announcement when a player joins the server, every map or every round:\n0.0 = disabled, 1.0 = every map, 2.0 = every round",FCVAR_PLUGIN, true, 0.0, true, 2.0);
	cvar_Bankdepositfee = CreateConVar("css_bank_deposit_fee","200","Fee, the players must pay for each deposit",FCVAR_PLUGIN);
	cvar_Bankinterest = CreateConVar("css_bank_interest","2.5","% of interest players will get per round",FCVAR_PLUGIN);
	cvar_Bankmindep = CreateConVar("css_bank_min_deposit","1000","Min. deposit amount, 0 to disable",FCVAR_PLUGIN);
	cvar_Bankpistolround = CreateConVar("css_bank_pistolrounds","1","Set the number of pistolrounds the bank is disabled, min. 0",FCVAR_PLUGIN);
	cvar_Bankidentity = CreateConVar("css_bank_identity","CSS Bank","Set the name of your bank",FCVAR_PLUGIN);
	cvar_Bankminplayers = CreateConVar("css_bank_min_players","2","The number of min players to activate bank, min 0",FCVAR_PLUGIN);
	cvar_Bankdbconfig = CreateConVar("css_bank_dbconfig","clientprefs","Set the database configuration listed in databases.cfg",FCVAR_PLUGIN);
	cvar_Bankmapprefixes = CreateConVar("css_bank_mapprefixes"," ","List the map prefixes where the bank is enabled or disabled. Related to the css_bank_mapmode Cvar\nSeparate with commas. e.g.: css_bank_mapprefixes \"gg_,fy_,aim_\"",FCVAR_PLUGIN);
	cvar_Bankmapmode = CreateConVar("css_bank_mapmode","0","0 = Disable bank during listed map prefixes, 1 = disable bank during NON-listed map prefixes (only listed maps enable bank)",FCVAR_PLUGIN);
	cvar_Bankdefaultautodep = CreateConVar("css_bank_autodep","0","Default auto deposit for new player",FCVAR_PLUGIN);
	cvar_Bankdefaultautowith = CreateConVar("css_bank_autowith","0","Default auto withdraw for new player",FCVAR_PLUGIN);
	cvar_Bankadminlimit = CreateConVar("css_bank_adminlimit","0","Maximun amount of money admins are allowed to have in the bank. 0 for no other limit.",FCVAR_PLUGIN);
	cvar_Bankadminflag = CreateConVar("css_bank_adminflag","d","Set the Admin Flag.\nFor mor information: http://wiki.alliedmods.net/Adding_Admins_%28SourceMod%29#Levels\nChanges require to reload plugin or restart server!",FCVAR_PLUGIN);
	cvar_Bankresetinterval = CreateConVar("css_bank_resetinterval","0","Set the number of days the bank should reset periodically, 0 for never",FCVAR_PLUGIN);
	cvar_Bankprunedb = CreateConVar("css_bank_prunedb","0","Set the number of days after inactive players will be deleted, 0 for never",FCVAR_PLUGIN);
	cvar_Bankaddtoadminmenu = CreateConVar("css_bank_add_to_adminmenu","1","Turns the adminmenu On/Off",FCVAR_PLUGIN);
	cvar_Bankmaxtransfer = CreateConVar("css_bank_transfer_limit","0","Maximum amount of money players are allowed to transfer. 0 for no limit",FCVAR_PLUGIN);
	cvar_Bankdefaultbank = CreateConVar("css_bank_default_bankmoney","0","Default amount of money new players get in the bank",FCVAR_PLUGIN);

	// create config file
	AutoExecConfig(true, "cssbank");

	// commands to use
	RegisterCommands();

	// add to !settings menu
	SetCookieMenuItem(PrefBankMenu, 0, "Bank Menu");

	//For late load
	if (LibraryExists("adminmenu"))
	{
		new Handle:topmenu;
		topmenu = GetAdminTopMenu();

		if (topmenu != INVALID_HANDLE)
			OnAdminMenuReady(topmenu);
	}

	g_iAccount = FindSendPropOffs("CCSPlayer", "m_iAccount");

	if (g_iAccount == -1)
		SetFailState("Could not find m_iAccount");

	HookEvent("round_start", EventRoundStart);

	decl String:GameName[32];
	GetGameFolderName(GameName, sizeof(GameName));
	if (StrContains(GameName, "csgo", false) != -1) {
		IsGameCsgo = true;
		g_bIsControllingBot  = FindSendPropInfo("CCSPlayer", "m_bIsControllingBot");
		if (g_bIsControllingBot == -1)
			SetFailState("Unable to locate m_bIsControllingBot");
			
		HookEvent("announce_phase_end", EventAnnouncePhaseEnd);
	}

	// Update the Plugin Version cvar
	SetConVarString(cvar_Bankversion, PLUGIN_VERSION);

	if (lateLoaded)
	{
		maxclients = MaxClients;
		GetCvars();
		CheckIsBankMap();
	}
}

public OnMapStart()
{
	maxclients = MaxClients;
	IsBankMap = true;
}

public OnMapEnd()
{
	IsBankMap = true;

	//UnhookConVarChange(cvar_Bankdbconfig, BankConVarChangedDB);
	//UnhookConVarChange(cvar_Bankenable, BankConVarChangedEn);
}

public OnConfigsExecuted()
{
	GetCvars();
	CheckIsBankMap();

	if (db == INVALID_HANDLE)
		ConnectToDatabase();

	new Flags = GetCommandFlags("bankadmin");
	if (Flags == INVALID_FCVAR_FLAGS)
		RegisterAdminCommand();

	if (lateLoaded)
		CreateTimer(0.2, ReConnectClients);

	HookConVarChange(cvar_Bankdbconfig, BankConVarChangedDB);
	HookConVarChange(cvar_Bankenable, BankConVarChangedEn);

	if (cvbankresetinterval > 0)
		CreateTimer(0.3, ResetBankInterval);
}

public BankConVarChangedEn(Handle:convar, const String:oldValue[], const String:newValue[])
{
	cvbankenable = GetConVarInt(cvar_Bankenable);
}

public BankConVarChangedDB(Handle:convar, const String:oldValue[], const String:newValue[])
{
	ConnectToDatabase();
}

public OnClientAuthorized(client)
{
	if (IsFakeClient(client))
		return;

	IsAdmin[client] = false;
	IsChatInput[client] = false;
	ClientChatInput[client] = 0;

	if (cvbankannounce > 0)
		IHateFloods[client] = true;
}

public OnClientPostAdminCheck(client)
{
	if (IsFakeClient(client))
		return;

	new AdminId:aid = GetUserAdmin(client);
	if (aid != INVALID_ADMIN_ID)
	{
		if (StrEqual(cvbankadminflag, "a", false) || StrEqual(cvbankadminflag, "reservation", false))
		{
			if (GetAdminFlag(aid, Admin_Reservation, Access_Effective))	IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "b", false) || StrEqual(cvbankadminflag, "generic", false))
		{
			if (GetAdminFlag(aid, Admin_Generic, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "c", false) || StrEqual(cvbankadminflag, "kick", false))
		{
			if (GetAdminFlag(aid, Admin_Kick, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "d", false) || StrEqual(cvbankadminflag, "ban", false))
		{
			if (GetAdminFlag(aid, Admin_Ban, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "e", false) || StrEqual(cvbankadminflag, "unban", false))
		{
			if (GetAdminFlag(aid, Admin_Unban, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "f", false) || StrEqual(cvbankadminflag, "slay", false))
		{
			if (GetAdminFlag(aid, Admin_Slay, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "g", false) || StrEqual(cvbankadminflag, "changemap", false))
		{
			if (GetAdminFlag(aid, Admin_Changemap, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "h", false) || StrEqual(cvbankadminflag, "cvar", false))
		{
			if (GetAdminFlag(aid, Admin_Convars, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "i", false) || StrEqual(cvbankadminflag, "config", false))
		{
			if (GetAdminFlag(aid, Admin_Config, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "j", false) || StrEqual(cvbankadminflag, "chat", false))
		{
			if (GetAdminFlag(aid, Admin_Chat, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "k", false) || StrEqual(cvbankadminflag, "vote", false))
		{
			if (GetAdminFlag(aid, Admin_Vote, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "l", false) || StrEqual(cvbankadminflag, "password", false))
		{
			if (GetAdminFlag(aid, Admin_Password, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "m", false) || StrEqual(cvbankadminflag, "rcon", false))
		{
			if (GetAdminFlag(aid, Admin_RCON, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "n", false) || StrEqual(cvbankadminflag, "cheats", false))
		{
			if (GetAdminFlag(aid, Admin_Cheats, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "z", false) || StrEqual(cvbankadminflag, "root ", false))
		{
			if (GetAdminFlag(aid, Admin_Root, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "o", false) || StrEqual(cvbankadminflag, "custom1", false))
		{
			if (GetAdminFlag(aid, Admin_Custom1, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "p", false) || StrEqual(cvbankadminflag, "custom2", false))
		{
			if (GetAdminFlag(aid, Admin_Custom2, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "q", false) || StrEqual(cvbankadminflag, "custom3", false))
		{
			if (GetAdminFlag(aid, Admin_Custom3, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "r", false) || StrEqual(cvbankadminflag, "custom4", false))
		{
			if (GetAdminFlag(aid, Admin_Custom4, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "s", false) || StrEqual(cvbankadminflag, "custom5", false))
		{
			if (GetAdminFlag(aid, Admin_Custom5, Access_Effective)) IsAdmin[client] = true;
		}
		else if (StrEqual(cvbankadminflag, "t", false) || StrEqual(cvbankadminflag, "custom6", false))
		{
			if (GetAdminFlag(aid, Admin_Custom6, Access_Effective)) IsAdmin[client] = true;
		}
	}

	NewClientConnected(client);
}

public OnClientDisconnect(client)
{
	/* for testing disabled (its not really used. probably caused the money-lost bug)
	if (IsClientInGame(client))
		SaveClientInfo(client);
	*/

	IsAdmin[client] = false;
	IsChatInput[client] = false;
	ClientChatInput[client] = 0;
}

// checks player not spectator
IsPlayerInTeam(client)
{
	new Team = GetClientTeam(client);

	if ((Team < 2) || (Team > 3))
		return false;

	return true;
}

// checks client
IsValidClient(client)
{
	if (client == 0)
		return false;

	else if (!IsClientConnected(client))
		return false;

	else if (IsFakeClient(client))
		return false;

	else if (!IsClientInGame(client))
		return false;

	return true;
}

// For CSGO
/**
 * Check if a player is controlling a bot
 * @param    client    Player's ClientID
 * @return 1 if player is controlling a bot or 0 if player is not controlling a bot
 */
IsPlayerControllingBot(client)
{
	if (IsGameCsgo)
		return GetEntData(client, g_bIsControllingBot , 1);

	return 0;
}

// counts real player
GetPlayerCount()
{
	new clients = 0;
	for (new i = 1; i <= maxclients; i++)
	{
		if (IsValidClient(i))
			clients++;
	}
	return clients;
}

ChatMessage(player_to, player_from, const String:text[], const String:name[])
{
	new Handle:hMessage = INVALID_HANDLE;

	hMessage = StartMessageOne("SayText2", player_to);

	/*
	BfWrite not working since CSGO update from 2013-01-23
	GetFeatureStatus for backwards compatibility pre csgo/sm1.5
	*/
	if (GetFeatureStatus(FeatureType_Native, "GetUserMessageType") == FeatureStatus_Available && GetUserMessageType() == UM_Protobuf) {
		PbSetInt(hMessage, "ent_idx", player_from);
		PbSetBool(hMessage, "chat", false);
		PbSetString(hMessage, "msg_name", text);

		PbAddString(hMessage, "params", name);
		PbAddString(hMessage, "params", "");
		PbAddString(hMessage, "params", "");
		PbAddString(hMessage, "params", "");
	} else {
		BfWriteByte(hMessage, player_from);
		BfWriteByte(hMessage, 0);
		BfWriteString(hMessage, text);
		BfWriteString(hMessage, name);
	}

	EndMessage();
}

GetCvars()
{
	cvbankenable = GetConVarInt(cvar_Bankenable);
	cvmaxbankmoney = GetConVarInt(cvar_Bankmaxbank);
	cvmaxbankmoney = cvmaxbankmoney == 0 ? 2000000000 : cvmaxbankmoney;
	GetConVarString(cvar_Bankidentity, cvplugin_name, sizeof(cvplugin_name));
	GetConVarString(cvar_Bankinterest, cvintereststr, sizeof(cvintereststr));
	cvfeeint = GetConVarInt(cvar_Bankdepositfee);
	cvinterestflt = GetConVarFloat(cvar_Bankinterest);
	cvbankannounce = GetConVarInt(cvar_Bankannounce);
	cvmindepamount = GetConVarInt(cvar_Bankmindep);
	cvpistolround = GetConVarInt(cvar_Bankpistolround);
	cvminrealplayers = GetConVarInt(cvar_Bankminplayers);
	cvdefaultautodep = GetConVarInt(cvar_Bankdefaultautodep);
	cvdefaultautowith = GetConVarInt(cvar_Bankdefaultautowith);
	cvbankadminlimit = GetConVarInt(cvar_Bankadminlimit);
	cvbankadminlimit = cvbankadminlimit == 0 ? 2000000000 : cvbankadminlimit;
	GetConVarString(cvar_Bankidentity, cvplugin_name, sizeof(cvplugin_name));
	GetConVarString(cvar_Bankadminflag, cvbankadminflag, sizeof(cvbankadminflag));
	cvbankresetinterval = GetConVarInt(cvar_Bankresetinterval);
	cvbankprunedb = GetConVarInt(cvar_Bankprunedb);
	cvmaxtransfer = GetConVarInt(cvar_Bankmaxtransfer);
	cvdefaultbank = GetConVarInt(cvar_Bankdefaultbank);

	if (FindConVar("mp_maxmoney")) {
		cvar_mp_maxmoney = FindConVar("mp_maxmoney");
		cvmpmaxmoney = GetConVarInt(cvar_mp_maxmoney);
	} else
		cvmpmaxmoney = 16000;

	cvar_mp_maxrounds = FindConVar("mp_maxrounds");
	cvmpmaxrounds = GetConVarInt(cvar_mp_maxrounds);

	if (FindConVar("mp_halftime")) {
		cvar_mp_halftime = FindConVar("mp_halftime");
		cvmphalftime = GetConVarInt(cvar_mp_halftime);
	} else
		cvmphalftime = 0;

	Format(plugin_name, sizeof(plugin_name), "%c\x0B%c[%s]%c", YELLOW, GREEN, cvplugin_name, YELLOW);
}

bool:IsBankEnable()
{
	if (!cvbankenable) return false;
	else if (!IsBankMap) return false;

	return true;
}

CheckIsBankMap()
{
	new String:cvmapprefixes[128];
	GetConVarString(cvar_Bankmapprefixes, cvmapprefixes, sizeof(cvmapprefixes));

	if (strlen(cvmapprefixes) > 2)
	{
		decl String:curMap[128], String:curMapPre[4];
		GetCurrentMap(curMap, sizeof(curMap));
		new cvbankmode = GetConVarInt(cvar_Bankmapmode);
		Format(curMapPre, sizeof(curMapPre), "%s", curMap);

		if (cvbankmode == 0)
			IsBankMap = StrContains(cvmapprefixes, curMapPre, false) < 0 ? true : false;
		else if (cvbankmode == 1)
			IsBankMap = StrContains(cvmapprefixes, curMapPre, false) < 0 ? false : true;
	}
	else
		IsBankMap = true;
}

bool:IsBankOn(client)
{
	new actrealplayers;
	actrealplayers = GetPlayerCount();

	if (!IsBankEnable()) return false;
	else if (!IsPlayerInTeam(client)) return false;
	else if (actrealplayers < cvminrealplayers) return false;
	else if (IsPistolRound()) return false;
	else if (IsPlayerControllingBot(client)) return false;

	return true;
}

bool:IsBankOnMsg(client)
{
	new actrealplayers;
	actrealplayers = GetPlayerCount();

	if (!IsBankEnable()) return false;
	else if (!IsPlayerInTeam(client)) return false;
	else if (actrealplayers < cvminrealplayers) {
		decl String:minplayers[8], String:minplayersstr[8], String:actualplayers[8];

		IntToString(cvminrealplayers, minplayers, sizeof(minplayers));
		IntToString(actrealplayers, actualplayers, sizeof(actualplayers));

		Format(minplayersstr, sizeof(minplayersstr), "%c%s%c", GREEN, minplayers, YELLOW);
		PrintToChat(client, "%t", "Not enough Players", plugin_name, actualplayers, minplayersstr, minplayers);
		return false;
	} else if (IsPistolRound()) {
		if (cvpistolround == 1)
			PrintToChat(client, "%t", "PistolRoundBlocked", plugin_name);
		else
			PrintToChat(client, "%t", "PistolRoundsBlocked", plugin_name);
		return false;
	} else if (IsPlayerControllingBot(client)) return false;

	return true;
}

bool:IsPistolRound()
{
	if (cvpistolround == 0)
		return false;

	new halfrounds;
	new teamscore_sum;

	teamscore_sum = GetTeamScore(2) + GetTeamScore(3);

	if ((cvmphalftime == 1) && (cvmpmaxrounds > 0))
	{
		halfrounds = cvmpmaxrounds/2;

		if (teamscore_sum >= halfrounds)
			teamscore_sum -= halfrounds;
	}

	if ((cvpistolround <= teamscore_sum) || (IsLastHalftimeRound))
		return false;

	return true;
}

// add to !settings menu
public PrefBankMenu(client, CookieMenuAction:action, any:info, String:buffer[], maxlen)
{
	if (action == CookieMenuAction_SelectOption)
		ShowBankMenu(client);
}

public Action:ReConnectClients(Handle:timer)
{
	for (new i = 1; i <= maxclients ; i++)
	{
		if (!IsValidClient(i)) continue;

		if (cvbankannounce > 0)
			IHateFloods[i] = true;

		new AdminId:aid = GetUserAdmin(i);
		if ((aid != INVALID_ADMIN_ID) && GetAdminFlag(aid, Admin_Generic, Access_Effective))
			IsAdmin[i] = true;
		else
			IsAdmin[i] = false;

		NewClientConnected(i);
	}
}

public Action:ResetBankInterval(Handle:timer)
{
	GetLastResetTimestamp();
	new nextreset = bankresettimestamp + (cvbankresetinterval * 86400);
	if (bankresettimestamp != 0 && GetTime() > nextreset )
		ResetBankMoney();
}

public EventRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (!IsBankEnable())
		return;

	IsLastHalftimeRound = false;

	new bankmoney, ingamemoney, autodeposit, autowithdraw;
	new String:MoneyGain[32], String:Money[32];
	new PluginMes;
	for (new i = 1; i <= maxclients ; i++)
	{
		if (!IsValidClient(i)) continue;

		PluginMes = GetPlugMes(i);

		if (IHateFloods[i] && (PluginMes == 1))
		{
			PrintToChat(i, "%t", "Available commands", plugin_name, GREEN, YELLOW, GREEN);
			if (cvbankannounce < 2)
				IHateFloods[i] = false;
		}

		if (!IsBankOn(i)) continue;
		// No Spectators...
		if (!IsPlayerInTeam(i)) continue;

		bankmoney = GetBankMoney(i);
		bankmoney += RoundFloat(FloatMul( float(bankmoney) , cvinterestflt / 100.0 ));

		if (IsAdmin[i] && (cvbankadminlimit > 0))
		{
			if (bankmoney > cvbankadminlimit)
				bankmoney = cvbankadminlimit;
		}
		else if ((cvmaxbankmoney > 0) && (bankmoney > cvmaxbankmoney))
			bankmoney = cvmaxbankmoney;

		if (bankmoney != GetBankMoney(i))
		{
			IntToMoney(bankmoney - GetBankMoney(i), MoneyGain, sizeof(MoneyGain));
			Format(Money, sizeof(Money), "%c%s%c", GREEN, MoneyGain, YELLOW);
			SetBankMoney(i, bankmoney);

			if (PluginMes == 1)
				PrintToChat(i, "%t", "Interested gained", plugin_name, Money);
		}

		ingamemoney = GetIngameMoney(i);
		autodeposit = GetAutoDeposit(i);
		autowithdraw = GetAutoWithdraw(i);

		new String:buffer[32];
		if ((autodeposit != 0) && (ingamemoney > autodeposit))
		{
			new autodep;
			autodep = ingamemoney - autodeposit - cvfeeint;
			if (autodep > cvmindepamount)
			{
				IntToString(autodep, buffer, sizeof(buffer));
				DepositClientMoney(i, buffer);
			}
		}
		else if ((autowithdraw != 0) && (ingamemoney < autowithdraw))
		{
			new autowith;
			autowith = autowithdraw - ingamemoney;
			IntToString(autowith, buffer, sizeof(buffer));
			WithdrawClientMoney(i, buffer);
		}
	}
}

public Action:EventAnnouncePhaseEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	IsLastHalftimeRound = true;
}
/*################################################################
##																##
##						Setter/Getter							##
##																##
################################################################*/

SetIngameMoney(client, amount)
{
	if (amount > cvmpmaxmoney)
		amount = cvmpmaxmoney;
	if (amount < 0)
		amount = 0;
	SetEntData(client, g_iAccount, amount, 4, true);
}

GetIngameMoney(client)
{
	return GetEntData(client, g_iAccount, 4);
}

SetBankMoney(client, amount)
{
	if (IsAdmin[client] && (cvbankadminlimit > 0))
	{
		if (amount > cvbankadminlimit)
			amount = cvbankadminlimit;
	}
	else if ((cvmaxbankmoney > 0) && (amount > cvmaxbankmoney))
		amount = cvmaxbankmoney;

	if (amount < 0)
		amount = 0;
	BankMoney[client] = amount;
	SaveClientInfo(client);
}

GetBankMoney(client)
{
	return BankMoney[client];
}

SetAutoDeposit(client, amount)
{
	AutoDeposit[client] = amount;
	SaveClientInfo(client);
}

GetAutoDeposit(client)
{
	return AutoDeposit[client];
}

SetAutoWithdraw(client, amount)
{
	AutoWithdraw[client] = amount;
	SaveClientInfo(client);
}

GetAutoWithdraw(client)
{
	return AutoWithdraw[client];
}

SetHideRank(client, value)
{
	HideRank[client] = value;
	SaveClientInfo(client);
}

GetHideRank(client)
{
	return HideRank[client];
}

SetPlugMes(client, value)
{
	PlugMes[client] = value;
	SaveClientInfo(client);
}

GetPlugMes(client)
{
	return PlugMes[client];
}